GNU Radio C++ API Reference: gr::io_signature Class Reference

| GNU Radio C++ API Reference 3.10.12.0 The Free & Open Software Radio Ecosystem |

Loading...
Searching...
No Matches
gr::io_signature Class Reference

i/o signature for input and output ports. More...

`#include <gnuradio/io_signature.h>`

## Public Types
typedef std::shared_ptr< io_signature > | sptr
using | default_buftype = buffer_double_mapped

## Public Member Functions
| ~io_signature ()
int | min_streams () const
int | max_streams () const
int | sizeof_stream_item (int index) const
std::vector< int > | sizeof_stream_items () const
buffer_type | stream_buffer_type (size_t index) const
gr_vector_buffer_type | stream_buffer_types () const

## Static Public Member Functions
static sptr | make (int min_streams, int max_streams, int sizeof_stream_item, buffer_type buftype=default_buftype::type)
| Create an i/o signature.
static sptr | make (int min_streams, int max_streams, const std::vector< size_t > &sizeof_stream_items, const gr::gr_vector_buffer_type &buftypes=gr::gr_vector_buffer_type(1, default_buftype::type))
| Create an i/o signature.
static sptr | make2 (int min_streams, int max_streams, int sizeof_stream_item1, int sizeof_stream_item2, buffer_type buftype1=default_buftype::type, buffer_type buftype2=default_buftype::type)
| Create an i/o signature.
static sptr | make3 (int min_streams, int max_streams, int sizeof_stream_item1, int sizeof_stream_item2, int sizeof_stream_item3, buffer_type buftype1=default_buftype::type, buffer_type buftype2=default_buftype::type, buffer_type buftype3=default_buftype::type)
| Create an i/o signature.
static sptr | makev (int min_streams, int max_streams, const std::vector< int > &sizeof_stream_items)
| Create an i/o signature.
static sptr | makev (int min_streams, int max_streams, const std::vector< int > &sizeof_stream_items, const gr_vector_buffer_type &buftypes)
| Create an i/o signature.

## Static Public Attributes
static constexpr int | IO_INFINITE = -1

## Friends
bool | operator== (const io_signature &lhs, const io_signature &rhs)

## Detailed Description

i/o signature for input and output ports.

misc

## Member Typedef Documentation

## ◆ default_buftype

using gr::io_signature::default_buftype = buffer_double_mapped

## ◆ sptr

typedef std::shared_ptr<io_signature> gr::io_signature::sptr

## Constructor & Destructor Documentation

## ◆ ~io_signature()

gr::io_signature::~io_signature | ( |  | ) |

## Member Function Documentation

## ◆ make2()

sptr gr::io_signature::make2 | ( | int | min_streams,
|  | int | max_streams,
|  | int | sizeof_stream_item1,
|  | int | sizeof_stream_item2,
|  | buffer_type | buftype1 = default_buftype::type,
|  | buffer_type | buftype2 = default_buftype::type )
| static

Create an i/o signature.

Parameters

  min_streams | specify minimum number of streams (>= 0)
  max_streams | specify maximum number of streams (>= min_streams or -1 -> infinite)
  sizeof_stream_item1 | specify the size of the items in the first stream
  sizeof_stream_item2 | specify the size of the items in the second and subsequent streams
  buftype1 | type of buffers the first stream should use (defaults to standard host double mapped buffer)
  buftype2 | type of buffers the second and subsequent streams should use (defaults to standard host double mapped buffer)

References max_streams(), min_streams(), and gr::buffer_double_mapped::type.

## ◆ make3()

sptr gr::io_signature::make3 | ( | int | min_streams,
|  | int | max_streams,
|  | int | sizeof_stream_item1,
|  | int | sizeof_stream_item2,
|  | int | sizeof_stream_item3,
|  | buffer_type | buftype1 = default_buftype::type,
|  | buffer_type | buftype2 = default_buftype::type,
|  | buffer_type | buftype3 = default_buftype::type )
| static

Create an i/o signature.

Parameters

  min_streams | specify minimum number of streams (>= 0)
  max_streams | specify maximum number of streams (>= min_streams or -1 -> infinite)
  sizeof_stream_item1 | specify the size of the items in the first stream
  sizeof_stream_item2 | specify the size of the items in the second stream
  sizeof_stream_item3 | specify the size of the items in the third and subsequent streams
  buftype1 | type of buffers the first stream should use (defaults to standard host double mapped buffer)
  buftype2 | type of buffers the second stream should use (defaults to standard host double mapped buffer)
  buftype3 | type of buffers the third and subsequent streams should use (defaults to standard host double mapped buffer)

References max_streams(), min_streams(), and gr::buffer_double_mapped::type.

## ◆ makev() [1/2]

sptr gr::io_signature::makev | ( | int | min_streams,
|  | int | max_streams,
|  | const std::vector< int > & | sizeof_stream_items )
| static

Create an i/o signature.

Parameters

  min_streams | specify minimum number of streams (>= 0)
  max_streams | specify maximum number of streams (>= min_streams or -1 -> infinite)
  sizeof_stream_items | specify the size of the items in the streams

If there are more streams than there are entries in sizeof_stream_items, the value of the last entry in sizeof_stream_items is used for the missing values. sizeof_stream_items must contain at least 1 entry.

References max_streams(), min_streams(), and sizeof_stream_items().

## ◆ makev() [2/2]

sptr gr::io_signature::makev | ( | int | min_streams,
|  | int | max_streams,
|  | const std::vector< int > & | sizeof_stream_items,
|  | const gr_vector_buffer_type & | buftypes )
| static

Create an i/o signature.

Parameters

  min_streams | specify minimum number of streams (>= 0)
  max_streams | specify maximum number of streams (>= min_streams or -1 -> infinite)
  sizeof_stream_items | specify the size of the items in the streams
  buftypes | the type of buffer each stream will should use

If there are more streams than there are entries in sizeof_stream_items, the value of the last entry in sizeof_stream_items is used for the missing values. sizeof_stream_items must contain at least 1 entry.

References max_streams(), min_streams(), and sizeof_stream_items().

## ◆ max_streams()

int gr::io_signature::max_streams | ( |  | ) | const
| inline

Referenced by make(), make(), make2(), make3(), makev(), and makev().

## ◆ min_streams()

int gr::io_signature::min_streams | ( |  | ) | const
| inline

Referenced by make(), make(), make2(), make3(), makev(), and makev().

## ◆ sizeof_stream_item()

int gr::io_signature::sizeof_stream_item | ( | int | index | ) | const

Referenced by make().

## ◆ sizeof_stream_items()

std::vector< int > gr::io_signature::sizeof_stream_items | ( |  | ) | const

Referenced by make(), makev(), and makev().

## ◆ stream_buffer_type()

buffer_type gr::io_signature::stream_buffer_type | ( | size_t | index | ) | const

## ◆ stream_buffer_types()

gr_vector_buffer_type gr::io_signature::stream_buffer_types | ( |  | ) | const

## Friends And Related Symbol Documentation

## ◆ operator==

bool operator== | ( | const io_signature & | lhs,
|  | const io_signature & | rhs )
| friend

## Member Data Documentation

## ◆ IO_INFINITE

int gr::io_signature::IO_INFINITE = -1
| staticconstexpr

The documentation for this class was generated from the following file:

- io_signature.h